unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  windows, Classes, SysUtils, Forms, Controls, Dialogs, ComCtrls, Menus,
  StdCtrls, LCLIntf, toolbarmenu;

type

  TToolBar = class(toolbarmenu.TMenuToolBar);

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    ToolBar1: TToolBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuItemClicks(Sender: TObject);
    procedure ToolBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ToolBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ToolBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    DeltaX,DeltaY: Integer;
    MouseX,MouseY: Integer;
    MoveMe: Boolean ;

  public

  end;

var
  Form1: TForm1;



implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ToolBar1.Menu:= MainMenu1;

  DeltaX := 0;
  DeltaY := 0;
  MouseX := 0;
  MouseY := 0;
  MoveMe := False;
  Edit1.Text := 'Left: ' + inttostr(Form1.Left);
  Edit2.Text := 'Top: ' + inttostr(Form1.Top);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.MenuItemClicks(Sender: TObject);
begin
  Memo1.Lines.Add(TimeToStr(now)+'   '+TMenuItem(Sender).Caption+' ausgewählt.');
end;



procedure TForm1.ToolBar1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
  If Button = mbRight then
    begin
      DeltaX := X;
      DeltaY := Y;
      MoveMe := true;
      ToolBar1.Cursor := crSizeAll;
      Form1.FormStyle := fsSystemStayOnTop;
    end;
end;


procedure TForm1.ToolBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
If MoveMe = True then
  begin
  Left := Left + X - DeltaX;
  Top := Top + Y - DeltaY;

  Edit1.Text := 'Left: ' + inttostr(Left);
  Edit2.Text := 'Top: ' + inttostr(Top);
  end;

end;


procedure TForm1.ToolBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

begin
  If Button = mbRight then
    begin
      Left := Left + DeltaX;
      Top := Top + DeltaY;
      MoveMe := False ;
      ToolBar1.Cursor := crDefault;
      Form1.Left := Left - DeltaX;
      Form1.Top := Top - DeltaY;
      Edit1.Text := 'Left: ' + inttostr(Form1.Left);
      Edit2.Text := 'Top: ' + inttostr(Form1.Top);
      Form1.FormStyle := fsNormal;

    end;
end;



end.

